#define READ   1
#define WRITE  0
sbit SCL=0xb4;
sbit SDA=0xB5;
unsigned char 	_i2c_error;      // bit array of error types
void          	_I2CBitDly(void);
void          	_I2CSCLHigh(void);
void           	I2CSendAddr(unsigned char addr, unsigned char rd);
void           	I2CSendByte(unsigned char bt);
unsigned char 	_I2CGetByte(unsigned char lastone);
unsigned char	read_time (unsigned char par);
void          	I2CSendStop(void);
#define 		I2CGetByte()     _I2CGetByte(0)
#define 		I2CGetLastByte() _I2CGetByte(1)

void _I2CBitDly(void)         // wait 4.7uS
{char j;for (j=8;j!=0;j--){}}

void _I2CSCLHigh(void)        // set SCL high, and wait for it to go high
{
  register int err;
  SCL = 1;
  while (! SCL)
  {
    err++;
    if (!err)
    {
      _i2c_error &= 0x02;     // SCL stuck, something's holding it down
      return;
    }
  }
}

void I2CSendAddr(unsigned char addr, unsigned char rd)
{
  SCL = 1;
  _I2CBitDly();
  SDA = 0;               // generate start
  _I2CBitDly();
  SCL = 0;
  _I2CBitDly();
  I2CSendByte(addr+rd);  // send address byte
}

void I2CSendByte(unsigned char bt)
{
  register unsigned char i;
  for (i=0; i<8; i++)
  {
    if (bt & 0x80) SDA = 1;      // send each bit, MSB first
    else SDA = 0;
    _I2CSCLHigh();
    _I2CBitDly();
    SCL = 0;
    _I2CBitDly();
    bt = bt << 1;
  }
  SDA = 1;                       // listen for ACK
  _I2CSCLHigh();
  _I2CBitDly();
  if (SDA)
    _i2c_error &= 0x01;          // ack didn't happen, may be nothing out there
  SCL = 0;
  _I2CBitDly();
}

unsigned char _I2CGetByte(unsigned char lastone) // lastone == 1 for last byte
{
  register unsigned char i, res;
  res = 0;
  for (i=0;i<8;i++)          // each bit at a time, MSB first
  {
    _I2CSCLHigh();
    _I2CBitDly();
    res *= 2;
    if (SDA) res++;
    SCL = 0;
    _I2CBitDly();
  }
  SDA = lastone;             // send ACK according to 'lastone'
  _I2CSCLHigh();
  _I2CBitDly();
  SCL = 0;
  SDA = 1;
  _I2CBitDly();
  return(res);
}

void I2CSendStop(void)
{
  SDA = 0;
  _I2CBitDly();
  _I2CSCLHigh();
  _I2CBitDly();
  SDA = 1;
  _I2CBitDly();
}

unsigned char read_time (unsigned char par)
{
unsigned char temp;
	I2CSendAddr(0xa0,WRITE);
	I2CSendByte(par);
	I2CSendAddr(0xa0,READ);
	temp=I2CGetLastByte();
	I2CSendStop();
return (temp);
}
//--------------
void write_time (unsigned char par1,par2)
{
	I2CSendAddr(0xa0,WRITE);
	I2CSendByte(par1);
	I2CSendByte(par2);
	I2CSendStop();
}
//-----------
unsigned char read_temp_h (unsigned char tt)
{
unsigned char temp;
	I2CSendAddr(tt,WRITE);
	I2CSendByte(0xaa);
	I2CSendAddr(tt,READ);
	temp=I2CGetByte();
	I2CSendStop();
return (temp);
}
//-----------
unsigned char read_temp_l (unsigned char tt)
{
unsigned char temp;
	I2CSendAddr(tt,WRITE);
	I2CSendByte(0xaa);
	I2CSendAddr(tt,READ);
	temp=I2CGetByte();
	temp=I2CGetByte();
	I2CSendStop();
return (temp);
}
//-----------
void start_temp (unsigned char tt)
{
	I2CSendAddr(tt,WRITE);
	I2CSendByte(0xee);
	I2CSendStop();
}

